#coding:utf-8

module Monpe

  #Alignmentのエラー
  class AlignmentError < StandardError ; end

  DEFAULT_LINESTYLE_DASHLEN = 1.0

  DEFAULT_ARROW_SIZE   = 0.5
  DEFAULT_ARROW_LENGTH = DEFAULT_ARROW_SIZE
  DEFAULT_ARROW_WIDTH  = DEFAULT_ARROW_SIZE

  LINECAPS_BUTT       = 0
  LINECAPS_ROUNT      = 1
  LINECAPS_PROJECTING = 2

  LINEJOIN_MITER = 0
  LINEJOIN_ROUND = 1
  LINEJOIN_BEVEL = 2

  LINESTYLE_SOLID        = 0
  LINESTYLE_DASHED       = 1
  LINESTYLE_DASH_DOT     = 2
  LINESTYLE_DASH_DOT_DOT = 3
  LINESTYLE_DOTTED       = 4

  FILLSTYLE_SOLID = 0

  ALIGN_LEFT   = 0
  ALIGN_CENTER = 1
  ALIGN_RIGHT  = 2

  FREE_ASPECT  = 0
  FIXED_ASPECT = 1
  SQURE_ASPECT = 2

  VALIGN_TOP        = 0
  VALIGN_BOTTOM     = 1
  VALIGN_CENTER     = 2
  VALIGN_FIRST_LINE = 3

  module_function

  #:call-seq:
  #  get_pango_alignment(align) -> PangoのAlignment定数
  #
  #MonpeのAlignment定数に対応するPangoの定数を返す
  #
  #*引数 align: MonpeのAlignment定数
  #*戻り値: PangoのAlignment定数
  def get_pango_alignment(align)
    case align
    when ALIGN_LEFT
      return Pango::ALIGN_LEFT
    when ALIGN_CENTER
      return Pango::ALIGN_CENTER
    when ALIGN_RIGHT
      return Pango::ALIGN_RIGHT
    else
      raise AlignmentError.new("invalid alignmnet #{align}")
    end
  end
end
