# coding:utf-8

module Monpe
  module Items

    #monpeの埋め込みオブジェクトの基底クラス
    class EmbedItem < Item

      #:nodoc:
      def initialize(info)
        super(info)
        @embed_id = @attrs["embed_id"]
        if @embed_id.nil? or @embed_id.empty?
          raise Monpe::ParserError.new("embed-item needs embed_id attribute")
        end
      end
    
      #:call-seq:
      #  get_embed_id -> String
      #
      #埋め込みIDを返す。
      #
      #* 戻り値: 埋め込みID
      def get_embed_id
        @embed_id
      end

      #:call-seq:
      #  get_embed_data -> String
      #
      #埋め込みデータを返す。
      #
      #* 戻り値: 埋め込みデータ
      def get_embed_data
        ""
      end

      #:call-seq:
      #  set_embed_data(data) -> nil
      #
      #埋め込みデータをセットする
      #
      #* 引数 data: 埋め込みデータ(文字列)
      #* 戻り値: nil
      def set_embed_data(data)
      end
  
      private
  
    end
  end
end
