# coding:utf-8

module Monpe
  module Items 

    #monpeのTextCircleオブジェクトに対応するクラス
    #
    class TextCircle < Item
  
      #:nodoc: 
      def initialize(info)
        super(info)
        @text = @attrs["text"]
        raise Monpe::ParserError.new("text-circle object needs text attribute") unless @text
      end

      #:nodoc: 
      def render(rdrr)
        rdrr.set_linewidth(0)
        rdrr.set_linestyle(Monpe::LINESTYLE_SOLID)
        rdrr.set_linejoin(Monpe::LINEJOIN_MITER)
        bb = rdrr.calc_text_bb(@text)
        bw = bb.right  - bb.left
        bh = bb.bottom - bb.top
        cx = bb.left   + bw / 2.0
        cy = bb.top    + bh / 2.0
        center = Monpe::Point.new(cx,cy)
        rdrr.draw_ellipse(center,bh,bh,@text.color)
        rdrr.draw_text(@text)
      end
  
      private
  
    end
  end
end
