# coding:utf-8

module Monpe
  module Items

    #monpeのTextオブジェクトに対応するクラス
    class Text < Item

      #:nodoc:
      def initialize(info)
        super(info)
        @text            = @attrs["text"]
        raise Monpe::ParserError.new("text object needs text attribute") unless @text
        @valign          = @attrs["valign"]          || Monpe::VALIGN_FIRST_LINE
        @fill_color      = @attrs["fill_color"]      || Monpe::Color.new(1,1,1)
        @show_background = @attrs["show_background"]
      end
  
      #:nodoc:
      def render(rdrr)
        if @show_background
          box = @obj_bb
          ul = Monpe::Point.new(box.left , box.top)
          lr = Monpe::Point.new(box.right, box.bottom)
          rdrr.fill_rect(ul,lr,@fill_color)
        end
        rdrr.draw_text(@text)
      end
  
      private
  
    end
  end
end
