# coding:utf-8

module Monpe

  #monpeのレイヤーに対応するクラス
  #
  class Layer

    #レイヤー名
    attr_accessor :name

    #描画フラグ
    attr_accessor :visible

    #描画フラグ
    attr_reader :items

    #:call-seq:
    #  new(name,visible = true) -> self
    #
    #レイヤーを作成する。
    #
    #* 引数 name: レイヤー名
    #* 引数 items: アイテムの配列
    #* 引数 visible: 描画フラグ(true=描画)
    #* 戻り値: self
    def initialize(name,items,visible = true)
      @name, @items, @visible = name, items, visible
      @items ||= []
    end

    #:call-seq:
    #  render(renderer) -> nil
    #
    #レイヤーの子要素をレンダリングする
    #
    #* 引数 renderer: Monpe::Renderer
    #* 戻り値: nil
    def render(renderer)
      @items.each do |item|
        item.render(renderer)
      end
      nil
    end

    private

  end
end
