# coding:utf-8

module Monpe

  # 用紙サイズを定義したクラス
  # クラスメソッドのみ
  class Paper

    class << self

      #:call-seq:
      #  get_paper_size(size) -> Hash
      #
      #用紙サイズ名から用紙サイズの情報を取得するメソッド。
      #
      #* 引数 size: 用紙サイズ(A4等)
      #* 戻り値: 横幅と高さの配列(cm)
      def get_paper_size(size)
        case size
        when "A0"
          return [84.1, 118.9]
        when "A1"
          return [59.4, 84.1]
        when "A2"
          return [42.0, 59.4]
        when "A3"
          return [29.7, 42.0]
        when "A4"
          return [21.0, 29.7]
        when "A5"
          return [14.8, 21.0]
        when "A6"
          return [10.5, 14.8]
        when "B0-Japan"
          return [103.0, 145.6]
        when "B1-Japan"
          return [72.8, 103.0]
        when "B2-Japan"
          return [51.5, 72.8]
        when "B3-Japan"
          return [36.4, 51.5]
        when "B4-Japan"
          return [25.7, 36.4]
        when "B5-Japan"
          return [18.2, 25.7]
        when "B6-Japan"
          return [12.8, 18.2]
        when "B0"
          return [100.0, 141.4]
        when "B1"
          return [70.7, 100.0]
        when "B2"
          return [50.0, 70.7]
        when "B3"
          return [35.3, 50.0]
        when "B4"
          return [25.0, 35.3]
        when "B5"
          return [17.6, 25.0]
        when "B6"
          return [12.5, 17.6]
        when "Letter"
          return [21.59, 27.94]
        when "Legal"
          return [21.59, 35.56]
        when "Ledger"
          return [27.9, 43.2]
        when "Half-Letter"
          return [21.59, 14.0]
        when "Executive"
          return [18.45, 26.74]
        when "Tabloid"
          return [28.01, 43.28]
        when "Monarch"
          return [9.8778, 19.12]
        when "SuperB"
          return [29.74, 43.28]
        when "Envelope-Commercial"
          return [10.51, 24.2]
        when "Envelope-Monarch"
          return [9.8778, 19.12]
        when "Envelope-DL"
          return [11.0, 22.0]
        when "Envelope-C5"
          return [16.2, 22.9]
        when "EuroPostcard"
          return [10.51, 14.81]
        when "Custom"
          return [10.0, 10.0]
        else
          return [10.0, 10.0]
        end
      end

      private
    end

  end
end
