# coding:utf-8

module Monpe

  #monpeの矩形範囲に対応するクラス
  #
  class Rectangle

    #左上x座標
    attr_accessor :left

    #左上y座標
    attr_accessor :top

    #右下x座標
    attr_accessor :right

    #右下y座標
    attr_accessor :bottom

    #:call-seq:
    #  new(left,top,right,bottom) -> self
    #
    #矩形範囲を作成する。
    #
    #* 引数 left: 左上x座標
    #* 引数 top: 左上y座標
    #* 引数 right: 右下x座標
    #* 引数 bottom: 右下y座標
    #* 戻り値: self
    def initialize(left,top,right,bottom)
      @left,@top,@right,@bottom = left,top,right,bottom
    end

    #:call-seq:
    #  union(r2) -> self
    #
    #矩形範囲を連結する
    #
    #* 引数 r2: 連結する矩形(Rectangle)
    #* 戻り値: self
    def union(r2)
      self.top    = [self.top,   r2.top].min
      self.bottom = [self.bottom,r2.bottom].max
      self.left   = [self.left,  r2.left].min
      self.right  = [self.right, r2.right].max
      self
    end

    private

  end
end
