# coding:utf-8

module Monpe

  module_function
  
  #:call-seq:
  #  export(reports,filename) -> bool 
  #
  #Monpe::Report[]を元にPDFファイルに出力する
  #
  #* 引数 reports: Monpe::ReportまたはMonpe::ReportのArray
  #* 引数 filename: 出力するPDFのパス
  #* 戻り値: 出力成功(true)、出力失敗(false)
  def export(reports,filename)
    unless reports.is_a?(Array)
      reports = [reports]
    end
    rdrr = Monpe::Renderer.new(filename)
    reports.each do |r|
      r.render(rdrr)
    end
    rdrr.finish
  end
end
