#coding:utf-8

gem 'minitest'
require 'minitest'
require 'minitest/autorun'
require 'minitest/unit'
require 'pp'
require 'json'
require 'test_helper'

class Monpe::TestItem < MiniTest::Unit::TestCase

  include Monpe::TestHelper

  def setup
    src = <<-EOS
      {"type":"Standard - Text",
       "version":"0",
       "id":"O79",
       "attributes":
        {"obj_pos":{"val":[4.68134, 1.21562], "t":"point"},
         "obj_bb":
          {"val":[4.68134, 0.777657, 10.2363, 1.32766], "t":"rectangle"},
         "text":
          {"val":
            {"type":"text",
             "attributes":
              {"string":{"val":"処　　方　　せ　　ん", "type":"string"},
               "font":
                {"val":{"name":"Courier", "family":"Takao明朝"},
                 "type":"font"},
               "height":{"val":0.6875, "type":"real"},
               "pos":{"val":[4.68134, 1.21562], "type":"point"},
               "color":{"val":"#000000", "type":"color"},
               "alignment":{"val":0, "type":"enum"},
               "single":{"val":0.3333, "type":"real"},
               "multi":{"val":0.27775, "type":"real"}}},
           "t":"composite"}}}
    EOS
    src.gsub!("\n","")
    @info_normal = JSON.parse(src)
    @info_invalid1 = {}

    src = <<-EOS
      {"type":"Standard - Text",
       "version":"0",
       "id":"O79",
       "attributes":
        {"obj_pos__":{"val":[4.68134, 1.21562], "t":"point"},
         "obj_bb__":
          {"val":[4.68134, 0.777657, 10.2363, 1.32766], "t":"rectangle"},
         "text":
          {"val":
            {"type":"text",
             "attributes":
              {"string":{"val":"処　　方　　せ　　ん", "type":"string"},
               "font":
                {"val":{"name":"Courier", "family":"Takao明朝"},
                 "type":"font"},
               "height":{"val":0.6875, "type":"real"},
               "pos":{"val":[4.68134, 1.21562], "type":"point"},
               "color":{"val":"#000000", "type":"color"},
               "alignment":{"val":0, "type":"enum"},
               "single":{"val":0.3333, "type":"real"},
               "multi":{"val":0.27775, "type":"real"}}},
           "t":"composite"}}}
    EOS
    src.gsub!("\n","")
    @info_invalid2 = JSON.parse(src)
  end

  def teardown
  end
  
  def test_new
    item = Monpe::Items::Item.new(@info_normal)
    assert(item)
  end

  def test_new_invalid1
    assert_raises(Monpe::Items::ItemError) do
      item = Monpe::Items::Item.new(@info_invalid1)
    end
  end

  def test_new_invalid2
    assert_raises(Monpe::Items::ItemError) do
      item = Monpe::Items::Item.new(@info_invalid2)
    end
  end

end
