#coding:utf-8

gem 'minitest'
require 'minitest'
require 'minitest/autorun'
require 'minitest/unit'
require 'pp'
require 'test_helper'
require 'json'

class Monpe::TestItemsEmbedText < MiniTest::Unit::TestCase

  include Monpe::TestHelper

  def setup
    info = Monpe::Parser.parse(data_file('test_items_embed_text.red'))
    @objects = info["layers"][0].items
  end

  def teardown
  end

  def export_a4(file)
    rdrr = Monpe::Renderer.new(out_file(file))
    rdrr.begin_render(21.0,29.7,{})
    yield rdrr
    rdrr.end_render
    rdrr.finish
  end
  
  def test_embed_text1
    export_a4(out_file('test_items_embed_text_.pdf')) do |rdrr|
      @objects[0].set_data("TEXT-1[1]あいうえお")
      @objects[0].render(rdrr)

      text= "NODE-1[1].TEXT-2[1].かきくけこさしすせ"
      @objects[1].set_data(text)
      @objects[1].render(rdrr)

      @objects[2].render(rdrr)

      text = "NODE-1[1].TEXT-2[2].ほげほげ"
      @objects[3].set_data(text)
      @objects[3].render(rdrr)
    end
  end
end
