#coding:utf-8

gem 'minitest'
require 'minitest'
require 'minitest/autorun'
require 'minitest/unit'
require 'pp'
require 'test_helper'
require 'json'

class Monpe::TestItemsText < MiniTest::Unit::TestCase

  include Monpe::TestHelper

  def setup
    info = Monpe::Parser.parse(data_file('test_items_text.red'))
    @objects = info["layers"][0].items
  end

  def teardown
  end

  def export_a4(file)
    rdrr = Monpe::Renderer.new(out_file(file))
    rdrr.begin_render(21.0,29.7,{})
    yield rdrr
    rdrr.end_render
    rdrr.finish
  end
  
  def test_text1
    export_a4(out_file('test_items_text_.pdf')) do |rdrr|
      @objects.each do |obj|
        obj.render(rdrr)
      end
    end
  end

  def test_text2
    report = Monpe::Report.new(data_file('test_items_text_ocrb.red'))
    Monpe.export(report,out_file('test_items_text_ocrb_.pdf'))
  end

end
