#coding:utf-8

gem 'minitest'
require 'minitest/autorun'
require 'minitest/unit'
require 'pp'
require 'test_helper'

class Monpe::TestParser < MiniTest::Unit::TestCase

  include Monpe::TestHelper

  def setup
  end

  def teardown
  end
  
  def test_parse_red
    info = Monpe::Parser.parse(data_file('test.red'))
    #pp info
    assert(info)
  end

  def test_parse_red2
    info = Monpe::Parser.parse(data_file('test2.red'))
    assert(info)
  end

  def test_parse_no_file
    assert_raises(Errno::ENOENT) do
      Monpe::Parser.parse(data_file('notfound.red'))
    end
  end

  def test_parse_invalid_format_red
    assert_raises(Monpe::FormatError) do
      Monpe::Parser.parse(data_file('invalid_format.red'))
    end
  end

  def test_parse_invalid_encoding_red
    assert_raises(Monpe::FormatError) do
      Monpe::Parser.parse(data_file('invalid_encoding.red'))
    end
  end


end
