#coding:utf-8

gem 'minitest'
require 'minitest/autorun'
require 'minitest/unit'
require 'pp'
require 'test_helper'
require 'open3'

class Monpe::TestExport < MiniTest::Unit::TestCase

  include Monpe::TestHelper

  DATA = %|{"NODE-1[0].TEXT-1":"NODE-1[1].TEXT-1","NODE-1[1].TEXT-1":"NODE-1[2].TEXT-1","NODE-1[2].TEXT-1":"NODE-1[3].TEXT-1","NODE-1[0].IMAGE-1":""}|

  def setup
  end

  def teardown
  end
  
  def test_red2data1
    red = data_file('test_monpe_print.red')
    out = out_file('test_monpe_print.json')
    Open3.popen3("bundle exec ruby -I lib bin/red2data #{red} -o #{out}") do |stdin,stdout,stderr,w|
      stdin.close
    end
    data = File.read(out)
    assert_equal(DATA,data)
  end

  def test_red2data2
    red = data_file('test_monpe_print.red')
    Open3.popen3("bundle exec ruby -I lib bin/red2data #{red}") do |stdin,stdout,stderr,w|
      stdin.close
      data = stdout.read.chomp!
      assert_equal(DATA,data)
    end
  end

  def test_red2data3
    red = data_file('test_monpe_print.red')
    Open3.popen3("bundle exec ruby -I lib bin/red2data /tmp/notfound") do |stdin,stdout,stderr,w|
      stdin.close
      st = w.value.exitstatus
      assert_equal(1,st)
    end
  end

  def test_red2data4
    red = data_file('test_monpe_print.red')
    Open3.popen3("bundle exec ruby -I lib bin/red2data /etc/hosts") do |stdin,stdout,stderr,w|
      stdin.close
      st = w.value.exitstatus
      assert_equal(1,st)
    end
  end

end
