#coding:utf-8

gem 'minitest'
require 'minitest'
require 'minitest/autorun'
require 'minitest/unit'
require 'pp'
require 'test_helper'
require 'json'

class Monpe::TestRendererImage < MiniTest::Unit::TestCase

  include Monpe::TestHelper

  def setup
  end

  def teardown
  end

  def export_a4(file)
    rdrr = Monpe::Renderer.new(out_file(file))
    rdrr.begin_render(21.0,29.7,{})
    yield rdrr
    rdrr.end_render
    rdrr.finish
  end
  
  def test_draw_image1
    export_a4(out_file('test_render_line_.pdf')) do |rdrr|
=begin
     [{"type"=>"Standard - Line",
       "version"=>"0",
       "id"=>"O0",
       "attributes"=>
        {"obj_pos"=>{"val"=>[3.8, 2.75], "t"=>"point"},
         "obj_bb"=>
          {"val"=>[3.73563, 1.48563, 7.06437, 2.81437], "t"=>"rectangle"},
         "conn_endpoints"=>{"val"=>[[3.8, 2.75], [7.0, 1.55]], "t"=>"2_point"},
         "numcp"=>{"val"=>1, "t"=>"int"}}},
=end
      st = Monpe::Point.new(3.8,2.75)
      ed = Monpe::Point.new(7.0,1.55)
      color = Monpe::Color.new(0.0,0.0,0.0)
      rdrr.set_linewidth(0.1)
      rdrr.draw_line(st,ed,color)
=begin
      {"type"=>"Standard - Line",
       "version"=>"0",
       "id"=>"O1",
       "attributes"=>
        {"obj_pos"=>{"val"=>[2.15, 3.85], "t"=>"point"},
         "obj_bb"=>
          {"val"=>[1.89591, 3.44591, 11.5041, 4.10409], "t"=>"rectangle"},
         "conn_endpoints"=>
          {"val"=>[[2.15, 3.85], [11.25, 3.7]], "t"=>"2_point"},
         "numcp"=>{"val"=>1, "t"=>"int"},
         "line_width"=>{"val"=>0.5, "t"=>"real"}}},
=end
      st = Monpe::Point.new(2.15,3.85)
      ed = Monpe::Point.new(11.25,3.7)
      color = Monpe::Color.new(0.0,0.0,0.0)
      rdrr.set_linewidth(0.5)
      rdrr.draw_line(st,ed,color)

=begin
      {"type"=>"Standard - Line",
       "version"=>"0",
       "id"=>"O2",
       "attributes"=>
        {"obj_pos"=>{"val"=>[4.0, 6.05], "t"=>"point"},
         "obj_bb"=>
          {"val"=>[3.93417, 5.98417, 13.1158, 10.0658], "t"=>"rectangle"},
         "conn_endpoints"=>
          {"val"=>[[4.0, 6.05], [13.05, 10.0]], "t"=>"2_point"},
         "numcp"=>{"val"=>1, "t"=>"int"},
         "line_style"=>{"val"=>1, "t"=>"enum"}}},
=end
      st = Monpe::Point.new(4.0,6.05)
      ed = Monpe::Point.new(13.05,10.0)
      color = Monpe::Color.new(0.0,0.0,0.0)
      rdrr.set_linewidth(0.1)
      rdrr.set_linestyle(Monpe::LINESTYLE_DASHED)
      rdrr.draw_line(st,ed,color)

=begin
      {"type"=>"Standard - Line",
       "version"=>"0",
       "id"=>"O3",
       "attributes"=>
        {"obj_pos"=>{"val"=>[3.09083, 7.53583], "t"=>"point"},
         "obj_bb"=>{"val"=>[3.025, 7.47, 12.2067, 11.5517], "t"=>"rectangle"},
         "conn_endpoints"=>
          {"val"=>[[3.09083, 7.53583], [12.1408, 11.4858]], "t"=>"2_point"},
         "numcp"=>{"val"=>1, "t"=>"int"},
         "line_style"=>{"val"=>1, "t"=>"enum"},
         "dashlength"=>{"val"=>0.5000000000000001, "t"=>"real"}}},
=end
      st = Monpe::Point.new(3.09,7.53)
      ed = Monpe::Point.new(12.14,11.4845)
      color = Monpe::Color.new(0.0,0.0,0.0)
      rdrr.set_linewidth(0.1)
      rdrr.set_dashlength(0.5)
      rdrr.set_linestyle(Monpe::LINESTYLE_DASHED)
      rdrr.draw_line(st,ed,color)

=begin
      {"type"=>"Standard - Line",
       "version"=>"0",
       "id"=>"O4",
       "attributes"=>
        {"obj_pos"=>{"val"=>[2.65, 11.9], "t"=>"point"},
         "obj_bb"=>
          {"val"=>[2.59743, 11.8474, 12.1526, 12.4526], "t"=>"rectangle"},
         "conn_endpoints"=>
          {"val"=>[[2.65, 11.9], [12.1, 12.4]], "t"=>"2_point"},
         "numcp"=>{"val"=>1, "t"=>"int"},
         "line_style"=>{"val"=>2, "t"=>"enum"}}},
=end
      st = Monpe::Point.new(2.65,11.9)
      ed = Monpe::Point.new(12.1,12.4)
      color = Monpe::Color.new(0.0,0.0,0.0)
      rdrr.set_linewidth(0.1)
      rdrr.set_dashlength(1.0)
      rdrr.set_linestyle(Monpe::LINESTYLE_DASH_DOT)
      rdrr.draw_line(st,ed,color)

=begin
      {"type"=>"Standard - Line",
       "version"=>"0",
       "id"=>"O5",
       "attributes"=>
        {"obj_pos"=>{"val"=>[14.85, 7.1], "t"=>"point"},
         "obj_bb"=>
          {"val"=>[14.7979, 7.04785, 15.3021, 16.2521], "t"=>"rectangle"},
         "conn_endpoints"=>
          {"val"=>[[14.85, 7.1], [15.25, 16.2]], "t"=>"2_point"},
         "numcp"=>{"val"=>1, "t"=>"int"},
         "line_style"=>{"val"=>3, "t"=>"enum"}}},
=end
      st = Monpe::Point.new(14.85,7.1)
      ed = Monpe::Point.new(15.25,16.2)
      color = Monpe::Color.new(0.0,0.0,0.0)
      rdrr.set_linewidth(0.1)
      rdrr.set_dashlength(1.0)
      rdrr.set_linestyle(Monpe::LINESTYLE_DASH_DOT_DOT)
      rdrr.draw_line(st,ed,color)

=begin
      {"type"=>"Standard - Line",
       "version"=>"0",
       "id"=>"O6",
       "attributes"=>
        {"obj_pos"=>{"val"=>[1.65, 13.75], "t"=>"point"},
         "obj_bb"=>
          {"val"=>[1.58277, 13.6828, 13.3172, 19.7172], "t"=>"rectangle"},
         "conn_endpoints"=>
          {"val"=>[[1.65, 13.75], [13.25, 19.65]], "t"=>"2_point"},
         "numcp"=>{"val"=>1, "t"=>"int"},
         "line_style"=>{"val"=>4, "t"=>"enum"}}},
=end
      st = Monpe::Point.new(1.65,13.75)
      ed = Monpe::Point.new(13.25,19.65)
      color = Monpe::Color.new(0.0,0.0,0.0)
      rdrr.set_linewidth(0.1)
      rdrr.set_dashlength(1.0)
      rdrr.set_linestyle(Monpe::LINESTYLE_DOTTED)
      rdrr.draw_line(st,ed,color)

=begin
      {"type"=>"Standard - Line",
       "version"=>"0",
       "id"=>"O7",
       "attributes"=>
        {"obj_pos"=>{"val"=>[15.15, 2.2], "t"=>"point"},
         "obj_bb"=>
          {"val"=>[15.083, 2.13301, 17.767, 7.41699], "t"=>"rectangle"},
         "conn_endpoints"=>
          {"val"=>[[15.15, 2.2], [17.7, 7.35]], "t"=>"2_point"},
         "numcp"=>{"val"=>1, "t"=>"int"}}}]}]}
=end
      st = Monpe::Point.new(15.15,2.2)
      ed = Monpe::Point.new(17.7,7.35)
      color = Monpe::Color.new(1.0,0.0,0.0)
      rdrr.set_linewidth(0.1)
      rdrr.set_dashlength(1.0)
      rdrr.set_linestyle(Monpe::LINESTYLE_SOLID)
      rdrr.draw_line(st,ed,color)
    end
  end
end
