#coding:utf-8

gem 'minitest'
require 'minitest'
require 'minitest/autorun'
require 'minitest/unit'
require 'pp'
require 'test_helper'
require 'json'

class Monpe::TestRendererShapes < MiniTest::Unit::TestCase

  include Monpe::TestHelper

  def setup
  end

  def teardown
  end

  def export_a4(file)
    rdrr = Monpe::Renderer.new(out_file(file))
    rdrr.begin_render(21.0,29.7,{})
    yield rdrr
    rdrr.end_render
    rdrr.finish
  end
  
  def test_draw_shapes1
    export_a4(out_file('test_render_shapes_.pdf')) do |rdrr|
=begin
     [{"type"=>"Standard - Box",
       "version"=>"0",
       "id"=>"O0",
       "attributes"=>
        {"obj_pos"=>{"val"=>[2.6, 1.95], "t"=>"point"},
         "obj_bb"=>{"val"=>[2.55, 1.9, 7.25, 5.0], "t"=>"rectangle"},
         "elem_corner"=>{"val"=>[2.6, 1.95], "t"=>"point"},
         "elem_width"=>{"val"=>4.6, "t"=>"real"},
         "elem_height"=>{"val"=>3.0, "t"=>"real"},
         "border_width"=>{"val"=>0.10000000149011612, "t"=>"real"},
         "show_background"=>{"val"=>true, "t"=>"bool"},
         "corner_radius"=>{"val"=>0.5, "t"=>"real"}}},
=end
      elem_corner = Monpe::Point.new(2.6,1.95)
      elem_width  = 4.6
      elem_height = 3.0
      tl          = elem_corner
      br          = Monpe::Point.new(elem_corner.x+elem_width, elem_corner.y+elem_height)
      color       = Monpe::Color.new(0,0,0)
      rdrr.set_linewidth(0.1)
      rdrr.draw_rounded_rect(tl,br,color,0.5)

=begin
      {"type"=>"Standard - Box",
       "version"=>"0",
       "id"=>"O1",
       "attributes"=>
        {"obj_pos"=>{"val"=>[9.7, 2.4], "t"=>"point"},
         "obj_bb"=>{"val"=>[9.65, 2.35, 14.85, 6.5], "t"=>"rectangle"},
         "elem_corner"=>{"val"=>[9.7, 2.4], "t"=>"point"},
         "elem_width"=>{"val"=>5.100000000000001, "t"=>"real"},
         "elem_height"=>{"val"=>4.05, "t"=>"real"},
         "border_width"=>{"val"=>0.10000000149011612, "t"=>"real"},
         "border_color"=>{"val"=>"#00ff00", "t"=>"color"},
         "show_background"=>{"val"=>true, "t"=>"bool"}}},
=end
      elem_corner = Monpe::Point.new(9.7,2.4)
      elem_width  = 5.1
      elem_height = 4.05
      tl          = elem_corner
      br          = Monpe::Point.new(elem_corner.x+elem_width, elem_corner.y+elem_height)
      color       = Monpe::Color.new(0,1,0)
      rdrr.set_linewidth(0.1)
      rdrr.draw_rect(tl,br,color)

=begin
      {"type"=>"Standard - Ellipse",
       "version"=>"0",
       "id"=>"O2",
       "attributes"=>
        {"obj_pos"=>{"val"=>[1.95, 6.25], "t"=>"point"},
         "obj_bb"=>{"val"=>[1.9, 6.2, 6.35, 13.0], "t"=>"rectangle"},
         "elem_corner"=>{"val"=>[1.95, 6.25], "t"=>"point"},
         "elem_width"=>{"val"=>4.3500000000000005, "t"=>"real"},
         "elem_height"=>{"val"=>6.699999999999999, "t"=>"real"},
         "border_width"=>{"val"=>0.10000000149011612, "t"=>"real"}}},
=end
      elem_corner = Monpe::Point.new(1.95,6.25)
      elem_width  = 4.35
      elem_height = 6.69
      center_x    = elem_corner.x + elem_width * 1.0 / 2.0
      center_y    = elem_corner.y + elem_height * 1.0 / 2.0
      center      = Monpe::Point.new(center_x,center_y)
      width       = elem_width
      height      = elem_height
      color       = Monpe::Color.new(0,0,0)
      rdrr.set_linewidth(0.1)
      rdrr.draw_ellipse(center,width,height,color)

=begin
      {"type"=>"Standard - Arc",
       "version"=>"0",
       "id"=>"O3",
       "attributes"=>
        {"obj_pos"=>{"val"=>[13.55, 10.85], "t"=>"point"},
         "obj_bb"=>
          {"val"=>[13.4794, 8.57942, 17.69, 12.7938], "t"=>"rectangle"},
         "conn_endpoints"=>
          {"val"=>[[13.55, 10.85], [15.5, 8.65]], "t"=>"2_point"},
         "curve_distance"=>{"val"=>3.473860507666993, "t"=>"real"},
         "line_width"=>{"val"=>0.10000000149011612, "t"=>"real"}}},
=end
# draw_arc 15.592103,10.695841 4.095827x4.095827 <184.317078,<92.577695
      center      = Monpe::Point.new(15.59,10.69)
      width       = 4.09
      height      = 4.09
      color       = Monpe::Color.new(0,0,0)
      rdrr.set_linewidth(0.1)
      rdrr.draw_arc(center,width,height,184.3,92.57,color)

=begin
      {"type"=>"Standard - Polygon",
       "version"=>"0",
       "id"=>"O4",
       "attributes"=>
        {"obj_pos"=>{"val"=>[4.95, 16.2], "t"=>"point"},
         "obj_bb"=>
          {"val"=>[4.83837, 14.3392, 14.0361, 22.3451], "t"=>"rectangle"},
         "poly_points"=>
          {"val"=>
            [[4.95, 16.2],
             [9.0, 14.4],
             [13.95, 20.2],
             [7.85, 22.25],
             [10.05, 19.05]],
           "t"=>"points"},
         "line_width"=>{"val"=>0.10000000149011612, "t"=>"real"},
         "show_background"=>{"val"=>true, "t"=>"bool"}}}]}]}
=end
      points = [
        Monpe::Point.new(4.95, 16.2),
        Monpe::Point.new(9.0, 14.4),
        Monpe::Point.new(13.95, 20.2),
        Monpe::Point.new(7.85, 22.25),
        Monpe::Point.new(10.05, 19.05),
      ]
      color = Monpe::Color.new(0,0,0)
      rdrr.set_linewidth(0.1)
      rdrr.draw_polygon(points,color)
    end
  end
end
