#coding:utf-8

gem 'minitest'
require 'minitest'
require 'minitest/autorun'
require 'minitest/unit'
require 'pp'
require 'test_helper'
require 'json'

class Monpe::TestRendererText < MiniTest::Unit::TestCase

  include Monpe::TestHelper

  def setup
    @takao_mincho_info = {"name"=>"Courier", "family"=>"Takao明朝"}
    @ocrb_info         = {"name"=>"Courier", "family"=>"OCRB"}
    @sans_info         = {"name"=>"Courier", "family"=>"Sans"}
  end

  def teardown
  end

  def export_a4(file)
    rdrr = Monpe::Renderer.new(out_file(file))
    rdrr.begin_render(21.0,29.7,{})
    yield rdrr
    rdrr.end_render
    rdrr.finish
  end
  
  def test_draw_text1
=begin
           {"type"=>"text",
            "attributes"=>
             {"string"=>{"val"=>"あいうえお", "type"=>"string"},
              "font"=>
               {"val"=>{"name"=>"Courier", "family"=>"Takao明朝"},
                "type"=>"font"},
              "height"=>{"val"=>0.8, "type"=>"real"},
              "pos"=>{"val"=>[5.0, 5.565], "type"=>"point"},
              "color"=>{"val"=>val='#000000', "type"=>"color"},
              "alignment"=>{"val"=>0, "type"=>"enum"}}},

            {"type"=>"text",
             "attributes"=>
              {"string"=>{"val"=>"あいうえお", "type"=>"string"},
               "font"=>
                {"val"=>{"name"=>"Courier", "family"=>"Takao明朝"},
                 "type"=>"font"},
               "height"=>{"val"=>0.8, "type"=>"real"},
               "pos"=>{"val"=>[6.6, 6.565], "type"=>"point"},
               "color"=>{"val"=>"#000000", "type"=>"color"},
               "alignment"=>{"val"=>1, "type"=>"enum"}}},

            {"type"=>"text",
             "attributes"=>
              {"string"=>{"val"=>"あいうえお", "type"=>"string"},
               "font"=>
                {"val"=>{"name"=>"Courier", "family"=>"Takao明朝"},
                 "type"=>"font"},
               "height"=>{"val"=>0.8, "type"=>"real"},
               "pos"=>{"val"=>[8.2, 7.565], "type"=>"point"},
               "color"=>{"val"=>"#000000", "type"=>"color"},
               "alignment"=>{"val"=>2, "type"=>"enum"}}},

            {"type"=>"text",
             "attributes"=>
              {"string"=>{"val"=>"abcdefg\nhijklmn", "type"=>"string"},
               "font"=>
                {"val"=>{"name"=>"Courier", "family"=>"Takao明朝"},
                 "type"=>"font"},
               "height"=>{"val"=>0.8, "type"=>"real"},
               "pos"=>{"val"=>[9.2, 3.75], "type"=>"point"},
               "color"=>{"val"=>"#000000", "type"=>"color"},
               "alignment"=>{"val"=>0, "type"=>"enum"}}},

            {"type"=>"text",
             "attributes"=>
              {"string"=>{"val"=>"0123456789", "type"=>"string"},
               "font"=>
                {"val"=>{"name"=>"Courier", "family"=>"OCRB"}, "type"=>"font"},
               "height"=>{"val"=>0.8, "type"=>"real"},
               "pos"=>{"val"=>[7.7, 1.55], "type"=>"point"},
               "color"=>{"val"=>"#000000", "type"=>"color"},
               "alignment"=>{"val"=>0, "type"=>"enum"}}},
=end
    export_a4(out_file('test_render_text_.pdf')) do |rdrr|
      text  = Monpe::Text.new(
        "あいうえお",
        Monpe::Font.new("Takao明朝",0),
        0.8,
        Monpe::Point.new(5.0,5.565),
        Monpe::Color.new(0,0,0),
        Monpe::ALIGN_LEFT)
      rdrr.draw_text(text)

      text  = Monpe::Text.new(
        "あいうえお",
        Monpe::Font.new("Takao明朝",0),
        0.8,
        Monpe::Point.new(6.6,6.565),
        Monpe::Color.new(0,0,0),
        Monpe::ALIGN_CENTER)
      rdrr.draw_text(text)

      text  = Monpe::Text.new(
        "あいうえお",
        Monpe::Font.new("Takao明朝",0),
        0.8,
        Monpe::Point.new(8.2,7.65),
        Monpe::Color.new(0,0,0),
        Monpe::ALIGN_RIGHT)
      rdrr.draw_text(text)

      text  = Monpe::Text.new(
        "abcdefg\nhijklmn",
        Monpe::Font.new("Takao明朝",0),
        0.8,
        Monpe::Point.new(9.2,3.75),
        Monpe::Color.new(0,0,0),
        Monpe::ALIGN_LEFT)
      rdrr.draw_text(text)

      text  = Monpe::Text.new(
        "0123456789",
        Monpe::Font.new("OCRB",0),
        0.8,
        Monpe::Point.new(7.7,1.55),
        Monpe::Color.new(0,0,0),
        Monpe::ALIGN_LEFT)
      rdrr.draw_text(text)

      text  = Monpe::Text.new(
        Time.now.to_s,
        Monpe::Font.new("sans",0),
        0.5,
        Monpe::Point.new(1.0,0.5),
        Monpe::Color.new(0,0,0),
        Monpe::ALIGN_LEFT)
      rdrr.draw_text(text)
    end
  end

  def test_draw_text2
    export_a4(out_file('test_draw_text2.pdf')) do |rdrr|
      text  = Monpe::Text.new(
        "あいうえお",
        Monpe::Font.new("Takao明朝",0),
        0.8,
        Monpe::Point.new(5.0,5.565),
        Monpe::Color.new(1.0,0,0),
        Monpe::ALIGN_LEFT)
      rdrr.draw_text(text)

      text  = Monpe::Text.new(
        "あいうえお",
        Monpe::Font.new("Takao明朝",0),
        0.8,
        Monpe::Point.new(6.6,6.565),
        Monpe::Color.new(0,1.0,0),
        Monpe::ALIGN_CENTER)
      rdrr.draw_text(text)

      text  = Monpe::Text.new(
        "あいうえお",
        Monpe::Font.new("Takao明朝",0),
        0.8,
        Monpe::Point.new(8.2,7.65),
        Monpe::Color.new(0.5,0.5,0.7),
        Monpe::ALIGN_RIGHT)
      rdrr.draw_text(text)
    end
  end
end
