#coding:utf-8

gem 'minitest'
require 'minitest/autorun'
require 'minitest/unit'
require 'pp'
require 'test_helper'

class Monpe::TestReportAll < MiniTest::Unit::TestCase

  include Monpe::TestHelper

  def setup
  end

  def teardown
  end
  
  def test_report_all1
    report = Monpe::Report.new(data_file('test_report_all.red'))
    rdrr = Monpe::Renderer.new(out_file('test_report_all_.pdf'))

    embed_objects = report.get_embed_objects
    obj = embed_objects['TEXT-1[0]']
    assert(obj)
    assert(obj.is_a?(Monpe::Items::EmbedText))

    obj = embed_objects['TEXT-1[1]']
    assert(obj)
    assert(obj.is_a?(Monpe::Items::EmbedText))

    obj = embed_objects['TEXT-1[2]']
    assert(obj)
    assert(obj.is_a?(Monpe::Items::EmbedText))

    obj = embed_objects['IMAGE-1']
    assert(obj)
    assert(obj.is_a?(Monpe::Items::EmbedImage))

    obj = report.get_embed_object('TEXT-1[0]')
    assert(obj)
    assert(obj.is_a?(Monpe::Items::EmbedText))

    data = report.get_embed_data
    assert(data['TEXT-1[0]'])
    assert(data['TEXT-1[1]'])
    assert(data['TEXT-1[2]'])
    assert(data['IMAGE-1'])

    data['TEXT-1[0]'] = 'あいうえおかきくけこさしすせそ'
    data['TEXT-1[1]'] = 'あいうえおかきくけこさしすせそ'
    data['TEXT-1[2]'] = 'あいうえおかきくけこさしすせそ'
    data['IMAGE-1']   = data_file('test.png')

    report.set_embed_data(data)

    report.render(rdrr)
    rdrr.end_render
    rdrr.finish
  end

end
